#!/usr/local/bin/perl

$current_file = "";
$outdir = "/tmp";
$found = 0;

while(<>){
  if(/^#line ([1-9][0-9]*) "([a-zA-Z\/.\-_]+)"/){
    $current_num = $1;
    $outfile = $outdir . "/" . $2;
    @path = split(/\//, $outfile);
    $tail = pop(@path);
    $newpath = join('/', @path);
    if(! -e $newpath){
      system("mkdir -p $newpath");
    }
    $current_file = $outfile;

    foreach $key (keys(%linenum)){
      if($key eq $current_file){
        $found = 1;
        last;
      }
    }
    if($found == 0){
      $linenum{$current_file} = 0;
    }

    next;
  }

  if(! $current_file){
    next;
  }

  open(OF, ">>$current_file");
  if($linenum{$current_file} > $current_num - 1){
    $diff = $linenum{$current_file} - ($current_num - 1);
    print OF "#####", $diff, "\n";
    $linenum{$current_file} = ($current_num - 1) - 1;
  }else{
    while($linenum{$current_file} < $current_num - 1){
      print OF "\n";
      $linenum{$current_file}++;
    }
  }
  print OF $_;
  $linenum{$current_file}++;
  $current_num++;
  close(OF);
}
